Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34921)
@@ -1698,10 +2462,17 @@
         Name => 'ExifImageWidth',
         Notes => 'called PixelXDimension by the EXIF spec.',
+        Writable => 'int16u',
+        Mandatory => 1,
     },
     0xa003 => {
         Name => 'ExifImageHeight',
         Notes => 'called PixelYDimension by the EXIF spec.',
-    },
-    0xa004 => 'RelatedSoundFile',
+        Writable => 'int16u',
+        Mandatory => 1,
+    },
+    0xa004 => {
+        Name => 'RelatedSoundFile',
+        Writable => 'string',
+    },
     0xa005 => {
         Name => 'InteropOffset',
@@ -1712,9 +2483,32 @@
             DirName => 'InteropIFD',
             Start => '$val',
-        },
+            MaxSubdirs => 1,
+        },
+    },
+    # the following 4 tags found in SubIFD1 of some Samsung SRW images
+    0xa010 => {
+        Name => 'SamsungRawPointersOffset',
+        IsOffset => 1,
+        OffsetPair => 0xa011,  # point to associated byte count
+    },
+    0xa011 => {
+        Name => 'SamsungRawPointersLength',
+        OffsetPair => 0xa010,  # point to associated offset
+    },
+    0xa101 => {
+        Name => 'SamsungRawByteOrder',
+        Format => 'undef',
+        # this is written incorrectly as string[1], but is "\0\0MM" or "II\0\0"
+        FixedSize => 4,
+        Count => 1,
+    },
+    0xa102 => {
+        Name => 'SamsungRawUnknown',
+        Unknown => 1,
     },
     0xa20b => {
         Name => 'FlashEnergy',
         Groups => { 2 => 'Camera' },
+        Writable => 'rational64u',
     },
     0xa20c => {
@@ -1723,10 +2517,19 @@
     },
     0xa20d => 'Noise',
-    0xa20e => { Name => 'FocalPlaneXResolution', Groups => { 2 => 'Camera' } },
-    0xa20f => { Name => 'FocalPlaneYResolution', Groups => { 2 => 'Camera' } },
+    0xa20e => {
+        Name => 'FocalPlaneXResolution',
+        Groups => { 2 => 'Camera' },
+        Writable => 'rational64u',
+    },
+    0xa20f => {
+        Name => 'FocalPlaneYResolution',
+        Groups => { 2 => 'Camera' },
+        Writable => 'rational64u',
+    },
     0xa210 => {
         Name => 'FocalPlaneResolutionUnit',
         Groups => { 2 => 'Camera' },
         Notes => 'values 1, 4 and 5 are not standard EXIF',
+        Writable => 'int16u',
         PrintConv => {
             1 => 'None', # (not standard EXIF)
@@ -1743,10 +2546,13 @@
         Name => 'SubjectLocation',
         Groups => { 2 => 'Camera' },
-    },
-    0xa215 => 'ExposureIndex',
+        Writable => 'int16u',
+        Count => 2,
+    },
+    0xa215 => { Name => 'ExposureIndex', Writable => 'rational64u' },
     0xa216 => 'TIFF-EPStandardID',
     0xa217 => {
         Name => 'SensingMethod',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         PrintConv => {
             1 => 'Not defined',
@@ -1757,8 +2563,11 @@
             7 => 'Trilinear',
             8 => 'Color sequential linear',
+            # 15 - used by DJI XT2
         },
     },
     0xa300 => {
         Name => 'FileSource',
+        Writable => 'undef',
+        ValueConvInv => '($val=~/^\d+$/ and $val < 256) ? chr($val) : $val',
         PrintConv => {
             1 => 'Film Scanner',
@@ -1771,4 +2580,6 @@
     0xa301 => {
         Name => 'SceneType',
+        Writable => 'undef',
+        ValueConvInv => 'chr($val)',
         PrintConv => {
             1 => 'Directly photographed',
@@ -1777,11 +2588,31 @@
     0xa302 => {
         Name => 'CFAPattern',
+        Writable => 'undef',
+        RawConv => 'Image::ExifTool::Exif::DecodeCFAPattern($self, $val)',
+        RawConvInv => q{
+            my @a = split ' ', $val;
+            return $val if @a <= 2; # also accept binary data for backward compatibility
+            return pack(GetByteOrder() eq 'II' ? 'v2C*' : 'n2C*', @a);
+        },
         PrintConv => 'Image::ExifTool::Exif::PrintCFAPattern($val)',
+        PrintConvInv => 'Image::ExifTool::Exif::GetCFAPattern($val)',
     },
     0xa401 => {
         Name => 'CustomRendered',
+        Writable => 'int16u',
+        Notes => q{
+            only 0 and 1 are standard EXIF, but other values are used by Apple iOS
+            devices
+        },
         PrintConv => {
             0 => 'Normal',
             1 => 'Custom',
+            2 => 'HDR (no original saved)', #32 non-standard (Apple iOS)
+            3 => 'HDR (original saved)',    #32 non-standard (Apple iOS)
+            4 => 'Original (for HDR)',      #32 non-standard (Apple iOS)
+            6 => 'Panorama', # non-standard (Apple iOS, horizontal or vertical)
+            7 => 'Portrait HDR',            #32 non-standard (Apple iOS)
+            8 => 'Portrait', # non-standard (Apple iOS, blurred background)
+            # 9 - also seen (Apple iOS) (HDR Portrait?)
         },
     },
@@ -1789,9 +2620,10 @@
         Name => 'ExposureMode',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         PrintConv => {
             0 => 'Auto',
             1 => 'Manual',
             2 => 'Auto bracket',
-            # have seen 3 for Samsung EX1 images - PH
+            # have seen 3 from Samsung EX1, NX30, NX200 - PH
         },
     },
@@ -1799,4 +2631,5 @@
         Name => 'WhiteBalance',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         # set Priority to zero to keep this WhiteBalance from overriding the
         # MakerNotes WhiteBalance, since the MakerNotes WhiteBalance and is more
@@ -1811,4 +2644,5 @@
         Name => 'DigitalZoomRatio',
         Groups => { 2 => 'Camera' },
+        Writable => 'rational64u',
     },
     0xa405 => {
@@ -1816,9 +2650,13 @@
         Notes => 'called FocalLengthIn35mmFilm by the EXIF spec.',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         PrintConv => '"$val mm"',
+        PrintConvInv => '$val=~s/\s*mm$//;$val',
     },
     0xa406 => {
         Name => 'SceneCaptureType',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
+        Notes => 'the value of 4 is non-standard, and used by some Samsung models',
         PrintConv => {
             0 => 'Standard',
@@ -1826,4 +2664,5 @@
             2 => 'Portrait',
             3 => 'Night',
+            4 => 'Other', # (non-standard Samsung, ref forum 5724)
         },
     },
@@ -1831,4 +2670,5 @@
         Name => 'GainControl',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         PrintConv => {
             0 => 'None',
@@ -1842,4 +2682,5 @@
         Name => 'Contrast',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         PrintConv => {
             0 => 'Normal',
@@ -1847,8 +2688,10 @@
             2 => 'High',
         },
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertParameter($val)',
     },
     0xa409 => {
         Name => 'Saturation',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         PrintConv => {
             0 => 'Normal',
@@ -1856,8 +2699,10 @@
             2 => 'High',
         },
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertParameter($val)',
     },
     0xa40a => {
         Name => 'Sharpness',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         PrintConv => {
             0 => 'Normal',
@@ -1865,4 +2710,5 @@
             2 => 'Hard',
         },
+        PrintConvInv => 'Image::ExifTool::Exif::ConvertParameter($val)',
     },
     0xa40b => {
@@ -1874,4 +2720,5 @@
         Name => 'SubjectDistanceRange',
         Groups => { 2 => 'Camera' },
+        Writable => 'int16u',
         PrintConv => {
             0 => 'Unknown',
@@ -1883,12 +2730,14 @@
     # 0xa40d - int16u: 0 (GE E1486 TW)
     # 0xa40e - int16u: 1 (GE E1486 TW)
-    0xa420 => 'ImageUniqueID',
+    0xa420 => { Name => 'ImageUniqueID', Writable => 'string' },
     0xa430 => { #24
         Name => 'OwnerName',
         Notes => 'called CameraOwnerName by the EXIF spec.',
+        Writable => 'string',
     },
     0xa431 => { #24
         Name => 'SerialNumber',
         Notes => 'called BodySerialNumber by the EXIF spec.',
+        Writable => 'string',
     },
     0xa432 => { #24
@@ -1898,13 +2747,85 @@
             by the EXIF spec.
         },
+        Writable => 'rational64u',
+        Count => 4,
         # convert to the form "12-20mm f/3.8-4.5" or "50mm f/1.4"
-        PrintConv => \&Image::ExifTool::Exif::PrintLensInfo,
-    },
-    0xa433 => 'LensMake', #24
-    0xa434 => 'LensModel', #24
-    0xa435 => 'LensSerialNumber', #24
-    0xa480 => 'GDALMetadata', #3
-    0xa481 => 'GDALNoData', #3
-    0xa500 => 'Gamma',
+        PrintConv => \&PrintLensInfo,
+        PrintConvInv => \&ConvertLensInfo,
+    },
+    0xa433 => { Name => 'LensMake',         Writable => 'string' }, #24
+    0xa434 => { Name => 'LensModel',        Writable => 'string' }, #24
+    0xa435 => { Name => 'LensSerialNumber', Writable => 'string' }, #24
+    0xa460 => { #Exif2.32
+        Name => 'CompositeImage',
+        Writable => 'int16u',
+        PrintConv => {
+            0 => 'Unknown',
+            1 => 'Not a Composite Image',
+            2 => 'General Composite Image',
+            3 => 'Composite Image Captured While Shooting',
+        },
+    },
+    0xa461 => { #Exif2.32
+        Name => 'CompositeImageCount',
+        Notes => q{
+            2 values: 1. Number of source images, 2. Number of images used.  Called
+            SourceImageNumberOfCompositeImage by the EXIF spec.
+        },
+        Writable => 'int16u',
+        Count => 2,
+    },
+    0xa462 => { #Exif2.32
+        Name => 'CompositeImageExposureTimes',
+        Notes => q{
+            11 or more values: 1. Total exposure time period, 2. Total exposure of all
+            source images, 3. Total exposure of all used images, 4. Max exposure time of
+            source images, 5. Max exposure time of used images, 6. Min exposure time of
+            source images, 7. Min exposure of used images, 8. Number of sequences, 9.
+            Number of source images in sequence. 10-N. Exposure times of each source
+            image. Called SourceExposureTimesOfCompositeImage by the EXIF spec.
+        },
+        Writable => 'undef',
+        RawConv => sub {
+            my $val = shift;
+            my @v;
+            my $i = 0;
+            for (;;) {
+                if ($i == 56 or $i == 58) {
+                    last if $i + 2 > length $val;
+                    push @v, Get16u(\$val, $i);
+                    $i += 2;
+                } else {
+                    last if $i + 8 > length $val;
+                    push @v, Image::ExifTool::GetRational64u(\$val, $i);
+                    $i += 8;
+                }
+            }
+            return join ' ', @v;
+        },
+        RawConvInv => sub {
+            my $val = shift;
+            my @v = split ' ', $val;
+            my $i;
+            for ($i=0; ; ++$i) {
+                last unless defined $v[$i];
+                $v[$i] = ($i == 7 or $i == 8) ? Set16u($v[$i]) : Image::ExifTool::SetRational64u($v[$i]);
+            }
+            return join '', @v;
+        },
+        PrintConv => sub {
+            my $val = shift;
+            my @v = split ' ', $val;
+            my $i;
+            for ($i=0; ; ++$i) {
+                last unless defined $v[$i];
+                $v[$i] = PrintExposureTime($v[$i]) unless $i == 7 or $i == 8;
+            }
+            return join ' ', @v;
+        },
+        PrintConvInv => '$val',
+    },
+    0xa480 => { Name => 'GDALMetadata',     Writable => 'string', WriteGroup => 'IFD0' }, #3
+    0xa481 => { Name => 'GDALNoData',       Writable => 'string', WriteGroup => 'IFD0' }, #3
+    0xa500 => { Name => 'Gamma',            Writable => 'rational64u' },
     0xafc0 => 'ExpandSoftware', #JD (Opanda)
     0xafc1 => 'ExpandLens', #JD (Opanda)
@@ -1913,4 +2834,5 @@
     0xafc4 => 'ExpandScanner', #JD (Opanda)
     0xafc5 => 'ExpandFlashLamp', #JD (Opanda)
+    0xb4c3 => { Name => 'HasselbladRawImage', Format => 'undef', Binary => 1 }, #IB
 #
 # Windows Media Photo / HD Photo (WDP/HDP) tags
@@ -2067,8 +2989,26 @@
         Writable => 'undef',
         WriteGroup => 'IFD0',
+        Binary => 1,
+        # (don't make Binary/Protected because we can't copy individual PrintIM tags anyway)
         Description => 'Print Image Matching',
         SubDirectory => {
             TagTable => 'Image::ExifTool::PrintIM::Main',
         },
+        PrintConvInv => '$val =~ /^PrintIM/ ? $val : undef',    # quick validation
+    },
+    0xc51b => { # (Hasselblad H3D)
+        Name => 'HasselbladExif',
+        Format => 'undef',
+        RawConv => q{
+            $$self{DOC_NUM} = ++$$self{DOC_COUNT};
+            $self->ExtractInfo(\$val, { ReEntry => 1 });
+            $$self{DOC_NUM} = 0;
+            return undef;
+        },
+    },
+    0xc573 => { #PH
+        Name => 'OriginalFileName',
+        Notes => 'used by some obscure software', # (possibly Swizzy Photosmacker?)
+        # (it is a 'string', but obscure, so don't make it writable)
     },
     0xc580 => { #20
@@ -2080,4 +3020,21 @@
         },
     },
+    # 0xc5d8 - found in CR2 images
+    # 0xc5d9 - found in CR2 images
+    0xc5e0 => { #forum8153 (CR2 images)
+        Name => 'CR2CFAPattern',
+        ValueConv => {
+            1 => '0 1 1 2',
+            2 => '2 1 1 0',
+            3 => '1 2 0 1',
+            4 => '1 0 2 1',
+        },
+        PrintConv => {
+            '0 1 1 2' => '[Red,Green][Green,Blue]',
+            '2 1 1 0' => '[Blue,Green][Green,Red]',
+            '1 2 0 1' => '[Green,Blue][Red,Green]',
+            '1 0 2 1' => '[Green,Red][Blue,Green]',
+        },
+    },
 #
 # DNG tags 0xc6XX and 0xc7XX (ref 2 unless otherwise stated)
@@ -2085,18 +3042,42 @@
     0xc612 => {
         Name => 'DNGVersion',
-        Notes => 'tags 0xc612-0xc761 are used in DNG images unless otherwise noted',
+        Notes => q{
+            tags 0xc612-0xc7b5 are defined by the DNG specification unless otherwise
+            noted.  See L<https://helpx.adobe.com/photoshop/digital-negative.html> for
+            the specification
+        },
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
+        Count => 4,
+        Protected => 1, # (confuses Apple Preview if written to a TIFF image)
         DataMember => 'DNGVersion',
         RawConv => '$$self{DNGVersion} = $val',
         PrintConv => '$val =~ tr/ /./; $val',
-    },
-    0xc613 => 'DNGBackwardVersion',
-    0xc614 => 'UniqueCameraModel',
+        PrintConvInv => '$val =~ tr/./ /; $val',
+    },
+    0xc613 => {
+        Name => 'DNGBackwardVersion',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
+        Count => 4,
+        Protected => 1,
+        PrintConv => '$val =~ tr/ /./; $val',
+        PrintConvInv => '$val =~ tr/./ /; $val',
+    },
+    0xc614 => {
+        Name => 'UniqueCameraModel',
+        Writable => 'string',
+        WriteGroup => 'IFD0',
+    },
     0xc615 => {
         Name => 'LocalizedCameraModel',
-        Format => 'string',
+        WriteGroup => 'IFD0',
+        %utf8StringConv,
         PrintConv => '$self->Printable($val, 0)',
+        PrintConvInv => '$val',
     },
     0xc616 => {
         Name => 'CFAPlaneColor',
+        WriteGroup => 'SubIFD', # (only for Validate)
         PrintConv => q{
             my @cols = qw(Red Green Blue Cyan Magenta Yellow White);
@@ -2107,4 +3088,5 @@
     0xc617 => {
         Name => 'CFALayout',
+        WriteGroup => 'SubIFD', # (only for Validate)
         PrintConv => {
             1 => 'Rectangular',
@@ -2120,39 +3102,196 @@
         },
     },
-    0xc618 => { Name => 'LinearizationTable', Binary => 1 },
-    0xc619 => 'BlackLevelRepeatDim',
-    0xc61a => 'BlackLevel',
-    0xc61b => { Name => 'BlackLevelDeltaH', %longBin },
-    0xc61c => { Name => 'BlackLevelDeltaV', %longBin },
-    0xc61d => 'WhiteLevel',
-    0xc61e => 'DefaultScale',
-    0xc61f => 'DefaultCropOrigin',
-    0xc620 => 'DefaultCropSize',
-    0xc621 => 'ColorMatrix1',
-    0xc622 => 'ColorMatrix2',
-    0xc623 => 'CameraCalibration1',
-    0xc624 => 'CameraCalibration2',
-    0xc625 => 'ReductionMatrix1',
-    0xc626 => 'ReductionMatrix2',
-    0xc627 => 'AnalogBalance',
-    0xc628 => 'AsShotNeutral',
-    0xc629 => 'AsShotWhiteXY',
-    0xc62a => 'BaselineExposure',
-    0xc62b => 'BaselineNoise',
-    0xc62c => 'BaselineSharpness',
-    0xc62d => 'BayerGreenSplit',
-    0xc62e => 'LinearResponseLimit',
+    0xc618 => {
+        Name => 'LinearizationTable',
+        Writable => 'int16u',
+        WriteGroup => 'SubIFD',
+        Count => -1,
+        Protected => 1,
+        Binary => 1,
+    },
+    0xc619 => {
+        Name => 'BlackLevelRepeatDim',
+        Writable => 'int16u',
+        WriteGroup => 'SubIFD',
+        Count => 2,
+        Protected => 1,
+    },
+    0xc61a => {
+        Name => 'BlackLevel',
+        Writable => 'rational64u',
+        WriteGroup => 'SubIFD',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc61b => {
+        Name => 'BlackLevelDeltaH',
+        %longBin,
+        Writable => 'rational64s',
+        WriteGroup => 'SubIFD',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc61c => {
+        Name => 'BlackLevelDeltaV',
+        %longBin,
+        Writable => 'rational64s',
+        WriteGroup => 'SubIFD',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc61d => {
+        Name => 'WhiteLevel',
+        Writable => 'int32u',
+        WriteGroup => 'SubIFD',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc61e => {
+        Name => 'DefaultScale',
+        Writable => 'rational64u',
+        WriteGroup => 'SubIFD',
+        Count => 2,
+        Protected => 1,
+    },
+    0xc61f => {
+        Name => 'DefaultCropOrigin',
+        Writable => 'int32u',
+        WriteGroup => 'SubIFD',
+        Count => 2,
+        Protected => 1,
+    },
+    0xc620 => {
+        Name => 'DefaultCropSize',
+        Writable => 'int32u',
+        WriteGroup => 'SubIFD',
+        Count => 2,
+        Protected => 1,
+    },
+    0xc621 => {
+        Name => 'ColorMatrix1',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc622 => {
+        Name => 'ColorMatrix2',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc623 => {
+        Name => 'CameraCalibration1',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc624 => {
+        Name => 'CameraCalibration2',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc625 => {
+        Name => 'ReductionMatrix1',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc626 => {
+        Name => 'ReductionMatrix2',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc627 => {
+        Name => 'AnalogBalance',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc628 => {
+        Name => 'AsShotNeutral',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc629 => {
+        Name => 'AsShotWhiteXY',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Count => 2,
+        Protected => 1,
+    },
+    0xc62a => {
+        Name => 'BaselineExposure',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+    },
+    0xc62b => {
+        Name => 'BaselineNoise',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+    },
+    0xc62c => {
+        Name => 'BaselineSharpness',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+    },
+    0xc62d => {
+        Name => 'BayerGreenSplit',
+        Writable => 'int32u',
+        WriteGroup => 'SubIFD',
+        Protected => 1,
+    },
+    0xc62e => {
+        Name => 'LinearResponseLimit',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+    },
     0xc62f => {
         Name => 'CameraSerialNumber',
         Groups => { 2 => 'Camera' },
+        Writable => 'string',
+        WriteGroup => 'IFD0',
     },
     0xc630 => {
         Name => 'DNGLensInfo',
         Groups => { 2 => 'Camera' },
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Count => 4,
         PrintConv =>\&PrintLensInfo,
-    },
-    0xc631 => 'ChromaBlurRadius',
-    0xc632 => 'AntiAliasStrength',
-    0xc633 => 'ShadowScale',
+        PrintConvInv => \&ConvertLensInfo,
+    },
+    0xc631 => {
+        Name => 'ChromaBlurRadius',
+        Writable => 'rational64u',
+        WriteGroup => 'SubIFD',
+        Protected => 1,
+    },
+    0xc632 => {
+        Name => 'AntiAliasStrength',
+        Writable => 'rational64u',
+        WriteGroup => 'SubIFD',
+        Protected => 1,
+    },
+    0xc633 => {
+        Name => 'ShadowScale',
+        Writable => 'rational64u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+    },
     0xc634 => [
         {
@@ -2162,8 +3301,9 @@
             Flags => 'SubIFD',
             Format => 'int32u',
-            # some utilites have problems unless this is int8u format:
+            # some utilities have problems unless this is int8u format:
             # - Adobe Camera Raw 5.3 gives an error
             # - Apple Preview 10.5.8 gets the wrong white balance
             FixFormat => 'int8u', # (stupid Sony)
+            WriteGroup => 'IFD0', # (for Validate)
             SubDirectory => {
                 DirName => 'SR2Private',
@@ -2175,13 +3315,23 @@
             Condition => '$$valPt =~ /^Adobe\0/',
             Name => 'DNGAdobeData',
+            Flags => [ 'Binary', 'Protected' ],
+            Writable => 'undef', # (writable directory!) (to make it possible to delete this mess)
+            WriteGroup => 'IFD0',
             NestedHtmlDump => 1,
             SubDirectory => { TagTable => 'Image::ExifTool::DNG::AdobeData' },
-            Format => 'undef',  # written incorrectly as int8u (change to undef for speed)
+            Format => 'undef',  # but written as int8u (change to undef for speed)
         },
         {
-            Condition => '$$valPt =~ /^(PENTAX |SAMSUNG)\0/',
+            # Pentax/Samsung models that write AOC maker notes in JPG images:
+            # K-5,K-7,K-m,K-x,K-r,K10D,K20D,K100D,K110D,K200D,K2000,GX10,GX20
+            # (Note: the following expression also appears in WriteExif.pl)
+            Condition => q{
+                $$valPt =~ /^(PENTAX |SAMSUNG)\0/ and
+                $$self{Model} =~ /\b(K(-[57mrx]|(10|20|100|110|200)D|2000)|GX(10|20))\b/
+            },
             Name => 'MakerNotePentax',
             MakerNotes => 1,    # (causes "MakerNotes header" to be identified in HtmlDump output)
             Binary => 1,
+            WriteGroup => 'IFD0', # (for Validate)
             # Note: Don't make this block-writable for a few reasons:
             # 1) It would be dangerous (possibly confusing Pentax software)
@@ -2194,14 +3344,52 @@
                 ByteOrder => 'Unknown', # easier to do this than read byteorder word
             },
-            Format => 'undef',  # written incorrectly as int8u (change to undef for speed)
-        },
+            Format => 'undef',  # but written as int8u (change to undef for speed)
+        },
+        {
+            # must duplicate the above tag with a different name for more recent
+            # Pentax models which use the "PENTAX" instead of the "AOC" maker notes
+            # in JPG images (needed when copying maker notes from DNG to JPG)
+            Condition => '$$valPt =~ /^(PENTAX |SAMSUNG)\0/',
+            Name => 'MakerNotePentax5',
+            MakerNotes => 1,
+            Binary => 1,
+            WriteGroup => 'IFD0', # (for Validate)
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Pentax::Main',
+                Start => '$valuePtr + 10',
+                Base => '$start - 10',
+                ByteOrder => 'Unknown',
+            },
+            Format => 'undef',
+        },
+        {
+            # Ricoh models such as the GR III
+            Condition => '$$valPt =~ /^RICOH\0(II|MM)/',
+            Name => 'MakerNoteRicohPentax',
+            MakerNotes => 1,
+            Binary => 1,
+            WriteGroup => 'IFD0', # (for Validate)
+            SubDirectory => {
+                TagTable => 'Image::ExifTool::Pentax::Main',
+                Start => '$valuePtr + 8',
+                Base => '$start - 8',
+                ByteOrder => 'Unknown',
+            },
+            Format => 'undef',
+        },
+        # the DJI FC2103 writes some interesting stuff here (with sections labelled
+        # awb_dbg_info, ae_dbg_info, ae_histogram_info, af_dbg_info, hiso, xidiri) - PH
         {
             Name => 'DNGPrivateData',
-            Binary => 1,
+            Flags => [ 'Binary', 'Protected' ],
             Format => 'undef',
+            Writable => 'int8u',
+            WriteGroup => 'IFD0',
         },
     ],
     0xc635 => {
         Name => 'MakerNoteSafety',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
         PrintConv => {
             0 => 'Unsafe',
@@ -2219,4 +3407,7 @@
     0xc65a => {
         Name => 'CalibrationIlluminant1',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
         SeparateTable => 'LightSource',
         PrintConv => \%lightSource,
@@ -2224,12 +3415,25 @@
     0xc65b => {
         Name => 'CalibrationIlluminant2',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
         SeparateTable => 'LightSource',
         PrintConv => \%lightSource,
     },
-    0xc65c => 'BestQualityScale',
+    0xc65c => {
+        Name => 'BestQualityScale',
+        Writable => 'rational64u',
+        WriteGroup => 'SubIFD',
+        Protected => 1,
+    },
     0xc65d => {
         Name => 'RawDataUniqueID',
         Format => 'undef',
+        Writable => 'int8u',
+        WriteGroup => 'IFD0',
+        Count => 16,
+        Protected => 1,
         ValueConv => 'uc(unpack("H*",$val))',
+        ValueConvInv => 'pack("H*", $val)',
     },
     0xc660 => { #3
@@ -2239,5 +3443,7 @@
     0xc68b => {
         Name => 'OriginalRawFileName',
-        Format => 'string', # sometimes written as int8u
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        %utf8StringConv,
     },
     0xc68c => {
@@ -2250,10 +3456,28 @@
         },
     },
-    0xc68d => 'ActiveArea',
-    0xc68e => 'MaskedAreas',
+    0xc68d => {
+        Name => 'ActiveArea',
+        Writable => 'int32u',
+        WriteGroup => 'SubIFD',
+        Count => 4,
+        Protected => 1,
+    },
+    0xc68e => {
+        Name => 'MaskedAreas',
+        Writable => 'int32u',
+        WriteGroup => 'SubIFD',
+        Count => -1,
+        Protected => 1,
+    },
     0xc68f => {
-        Name => 'AsShotICCProfile',
+        Name => 'AsShotICCProfile', # (writable directory)
         Binary => 1,
         Writable => 'undef', # must be defined here so tag will be extracted if specified
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        WriteCheck => q{
+            require Image::ExifTool::ICC_Profile;
+            return Image::ExifTool::ICC_Profile::ValidateICC(\$val);
+        },
         SubDirectory => {
             DirName => 'AsShotICCProfile',
@@ -2261,7 +3485,13 @@
         },
     },
-    0xc690 => 'AsShotPreProfileMatrix',
+    0xc690 => {
+        Name => 'AsShotPreProfileMatrix',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
     0xc691 => {
-        Name => 'CurrentICCProfile',
+        Name => 'CurrentICCProfile', # (writable directory)
         Binary => 1,
         Writable => 'undef', # must be defined here so tag will be extracted if specified
@@ -2270,7 +3500,26 @@
             TagTable => 'Image::ExifTool::ICC_Profile::Main',
         },
-    },
-    0xc692 => 'CurrentPreProfileMatrix',
-    0xc6bf => 'ColorimetricReference',
+        Writable => 'undef',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        WriteCheck => q{
+            require Image::ExifTool::ICC_Profile;
+            return Image::ExifTool::ICC_Profile::ValidateICC(\$val);
+        },
+    },
+    0xc692 => {
+        Name => 'CurrentPreProfileMatrix',
+        Writable => 'rational64s',
+        WriteGroup => 'IFD0',
+        Count => -1,
+        Protected => 1,
+    },
+    0xc6bf => {
+        Name => 'ColorimetricReference',
+        Writable => 'int16u',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+    },
+    0xc6c5 => { Name => 'SRawType', Description => 'SRaw Type', WriteGroup => 'IFD0' }, #exifprobe (CR2 proprietary)
     0xc6d2 => { #JD (Panasonic DMC-TZ5)
         # this text is UTF-8 encoded (hooray!) - PH (TZ5)
@@ -2278,8 +3527,11 @@
         Format => 'string', # written incorrectly as 'undef'
         Notes => 'proprietary Panasonic tag used for baby/pet name, etc',
+        Writable => 'undef',
+        WriteGroup => 'IFD0',
         # panasonic always records this tag (64 zero bytes),
         # so ignore it unless it contains valid information
         RawConv => 'length($val) ? $val : undef',
         ValueConv => '$self->Decode($val, "UTF8")',
+        ValueConvInv => '$self->Encode($val,"UTF8")',
     },
     0xc6d3 => { #PH (Panasonic DMC-FS7)
@@ -2287,15 +3539,31 @@
         Format => 'string', # written incorrectly as 'undef'
         Notes => 'proprietary Panasonic tag used for baby/pet name with age',
+        Writable => 'undef',
+        WriteGroup => 'IFD0',
         # panasonic always records this tag (128 zero bytes),
         # so ignore it unless it contains valid information
         RawConv => 'length($val) ? $val : undef',
         ValueConv => '$self->Decode($val, "UTF8")',
-    },
-    0xc6f3 => 'CameraCalibrationSig',
-    0xc6f4 => 'ProfileCalibrationSig',
+        ValueConvInv => '$self->Encode($val,"UTF8")',
+    },
+    # 0xc6dc - int32u[4]: found in CR2 images (PH, 7DmkIII)
+    # 0xc6dd - int16u[256]: found in CR2 images (PH, 5DmkIV)
+    0xc6f3 => {
+        Name => 'CameraCalibrationSig',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        %utf8StringConv,
+    },
+    0xc6f4 => {
+        Name => 'ProfileCalibrationSig',
+        WriteGroup => 'IFD0',
+        Protected => 1,
+        %utf8StringConv,
+    },
     0xc6f5 => {
         Name => 'ProfileIFD', # (ExtraCameraProfiles)
         Groups => { 1 => 'ProfileIFD' },
         Flags => 'SubIFD',
+        WriteGroup => 'IFD0', # (only for Validate)
         SubDirectory => {
             ProcessProc => \&ProcessTiffIFD,
